package com.edankert.examples.jdom;

import java.io.IOException;
import java.util.HashMap;
import java.util.List;

import org.jdom.Content;
import org.jdom.Document;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

import org.jaxen.JaxenException;
import org.jaxen.SimpleNamespaceContext;
import org.jaxen.XPath;
import org.jaxen.jdom.JDOMXPath;

public class XPathExample {

    public static void main(String[] args) {
		try {
			SAXBuilder builder = new SAXBuilder();			
			Document document = builder.build("file:catalog.xml");
			
            HashMap<String, String> map = new HashMap<String, String>();
			map.put("edx", "http://www.edankert.com/examples/");
			
			XPath xpath = new JDOMXPath("//edx:cd");
			xpath.setNamespaceContext(new SimpleNamespaceContext(map));
			
			List nodes = xpath.selectNodes(document);
			
			for (int i = 0; i < nodes.size(); i++) {
				System.out.println( ((Content)nodes.get(i)).getValue());
			}
  
		} catch (JaxenException e) {
			// An error occurred performing the XPath
			e.printStackTrace();
		} catch (IOException e) { 
			// An error occurred opening the document
			e.printStackTrace();
		} catch (JDOMException e) { 
			// An error occurred parsing the document
			e.printStackTrace();
		}
	}
}
